public interface IDataSetIndexer<TDataType, TIndexType>
{
    public TDataType Get<TGenericCollectionContentType>(List<TGenericCollectionContentType> collection, IDataIndex<TIndexType> index);
    public TDataType Get<TGenericCollectionContentType>(List<TGenericCollectionContentType> collection, params TIndexType[] indices);
    public TDataType GetAtIndex(List<TDataType> collection, TIndexType index);

    public TDataType GetAtIndex(List<List<TDataType>> collection, TIndexType x, TIndexType y);

    public TDataType GetAtIndex(List<List<List<TDataType>>> collection, TIndexType x, TIndexType y, TIndexType z);
}