public class DefaultPositionalDataIndex : IDataIndex<int>
{
    private List<int> indices = new List<int>();

    public DefaultPositionalDataIndex(params int[] indices)
    {
        this.indices.AddRange(indices);
    }

    public IList<int> GetIndices()
    {
        return indices;
    }
}