﻿namespace Parsing.Schema;

[Flags]
public enum BlockType
{
    Integer = 1,
    Char = 2,
    String = 4,
    // technically not a block type but keeping it here for consistency/having all types in one place
    Fragment = 8,
    FixedRepetition = 16,
    GreedyRepetition = 32,
    NonZeroRepetition = 64,
}
