﻿namespace Parsing.Tokenization;

using Parsing.Schema;

public class StringToken : IValueToken<string>
{
    private string word;

    public StringToken(string word)
    {
        this.word = word;
    }

    public string GetText()
    {
        return word;
    }

    public string GetValue()
    {
        return word;
    }

    public InputType GetInputType()
    {
        return InputType.String;
    }
}
